package cz.jezek.lab11;

import static java.lang.System.out;
import static java.util.stream.Collectors.joining;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

public class StreamMain {

  public static void main(String[] args) {
    Tournament tournament = loadTournament();

    printStatAboutTournament(tournament);

    saveTournament(tournament);
    
  }

  public static void printStatAboutTournament(Tournament tournament) {
    System.out.println(tournament);
    Player player = tournament.getRandomPlayer();

    System.out.println(player);
    System.out.print("Number of matches: ");
    //TODO 3.a Show the number of matches played by a given player (using Streams)
    //filter
    out.println( 
    		tournament.getMatches()
    		 		  .stream()
    		 		  .filter(m -> m.getOponents().contains(player))
    		 		  .count());
    
    System.out.print("Goals scored: ");
    //TODO 3.b Show the number of goals scored by a given player (help Streams)
    //IntStream <- mapToInt()
    //sum
    System.out.print(tournament.getMatches()
								  .stream()
								  .filter(m -> m.getOponents().contains(player))
								  .mapToInt( m-> m.getScoreForPlayer(player))
								  .sum());
    

    Oponents oponents = new Oponents(tournament.getRandomPlayer(),
        tournament.getRandomPlayer());
    System.out.println("Mutual statistics of oponents:" + oponents);
    
    System.out.print("Matches: ");
    System.out.println(tournament.getMatches()
			.stream()
			.filter(m -> m.getOponents().equals(oponents))
			.map(Object::toString)
			.collect(joining("\n")));
    //TODO 4.a List the matches played between the given players (using the stream)
    System.out.print("Number of mathes: ");
    //TODO 4.b Print the number of matches played between the given players (using the stream)
    System.out.print("Match with the largest total number:");
    System.out.println(tournament.getMatches()
    							.stream()
    							.filter(m -> m.getOponents().equals(oponents))
    							.mapToInt(m -> m.getPlayer1Scorel() + m.getPlayer2Scorel())
    							.max()
    							.orElse(0));
    //TODO 4.c Show match with the largest total number (sum of both players) scored goals between relevant players (help Streams)
  }

  public static Tournament loadTournament() {
    try(ObjectInputStream oos = new ObjectInputStream(new FileInputStream("tournament.obj"))) {
    	return (Tournament) oos.readObject();
	} catch (IOException | ClassNotFoundException e) {
		e.printStackTrace();
		return null;
	}
  }

  public static void saveTournament(Tournament tournament) {
    //TODO 5.a Save the tournament to a file using object serialization.
	  try (ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream("tournament.obj"))) {
		  oos.writeObject(tournament);
	} catch (IOException e) {
		e.printStackTrace();
	}
  }
}
